Hardware Locality (hwloc): Object Types

Hardware Locality (hwloc) 1.9

- Main Page
- Related Pages
- Modules
- Data Structures

Typedefs | Enumerations | Functions
Object Types

## Typedefs
typedef enum hwloc_obj_cache_type_e | hwloc_obj_cache_type_t
typedef enum hwloc_obj_bridge_type_e | hwloc_obj_bridge_type_t
typedef enum hwloc_obj_osdev_type_e | hwloc_obj_osdev_type_t

## Enumerations
enum | hwloc_obj_type_t { HWLOC_OBJ_SYSTEM, HWLOC_OBJ_MACHINE, HWLOC_OBJ_NODE, HWLOC_OBJ_SOCKET, HWLOC_OBJ_CACHE, HWLOC_OBJ_CORE, HWLOC_OBJ_PU, HWLOC_OBJ_GROUP, HWLOC_OBJ_MISC, HWLOC_OBJ_BRIDGE, HWLOC_OBJ_PCI_DEVICE, HWLOC_OBJ_OS_DEVICE, HWLOC_OBJ_TYPE_MAX }
enum | hwloc_obj_cache_type_e { HWLOC_OBJ_CACHE_UNIFIED, HWLOC_OBJ_CACHE_DATA, HWLOC_OBJ_CACHE_INSTRUCTION }
enum | hwloc_obj_bridge_type_e { HWLOC_OBJ_BRIDGE_HOST, HWLOC_OBJ_BRIDGE_PCI }
enum | hwloc_obj_osdev_type_e { HWLOC_OBJ_OSDEV_BLOCK, HWLOC_OBJ_OSDEV_GPU, HWLOC_OBJ_OSDEV_NETWORK, HWLOC_OBJ_OSDEV_OPENFABRICS, HWLOC_OBJ_OSDEV_DMA, HWLOC_OBJ_OSDEV_COPROC }
enum | hwloc_compare_types_e { HWLOC_TYPE_UNORDERED }

## Functions
int | hwloc_compare_types (hwloc_obj_type_t type1, hwloc_obj_type_t type2)

## Detailed Description

## Typedef Documentation

typedef enum hwloc_obj_bridge_type_e hwloc_obj_bridge_type_t

Type of one side (upstream or downstream) of an I/O bridge.

typedef enum hwloc_obj_cache_type_e hwloc_obj_cache_type_t

Cache type.

typedef enum hwloc_obj_osdev_type_e hwloc_obj_osdev_type_t

Type of a OS device.

## Enumeration Type Documentation

enum hwloc_compare_types_e

Enumerator
HWLOC_TYPE_UNORDERED | Value returned by hwloc_compare_types when types can not be compared.

enum hwloc_obj_bridge_type_e

Type of one side (upstream or downstream) of an I/O bridge.

Enumerator
HWLOC_OBJ_BRIDGE_HOST | Host-side of a bridge, only possible upstream.
HWLOC_OBJ_BRIDGE_PCI | PCI-side of a bridge.

enum hwloc_obj_cache_type_e

Cache type.

Enumerator
HWLOC_OBJ_CACHE_UNIFIED | Unified cache.
HWLOC_OBJ_CACHE_DATA | Data cache.
HWLOC_OBJ_CACHE_INSTRUCTION | Instruction cache. Only used when the HWLOC_TOPOLOGY_FLAG_ICACHES topology flag is set.

enum hwloc_obj_osdev_type_e

Type of a OS device.

Enumerator
HWLOC_OBJ_OSDEV_BLOCK | Operating system block device. For instance "sda" on Linux.
HWLOC_OBJ_OSDEV_GPU | Operating system GPU device. For instance ":0.0" for a GL display, "card0" for a Linux DRM device.
HWLOC_OBJ_OSDEV_NETWORK | Operating system network device. For instance the "eth0" interface on Linux.
HWLOC_OBJ_OSDEV_OPENFABRICS | Operating system openfabrics device. For instance the "mlx4_0" InfiniBand HCA device on Linux.
HWLOC_OBJ_OSDEV_DMA | Operating system dma engine device. For instance the "dma0chan0" DMA channel on Linux.
HWLOC_OBJ_OSDEV_COPROC | Operating system co-processor device. For instance "mic0" for a Xeon Phi (MIC) on Linux, "opencl0d0" for a OpenCL device, "cuda0" for a CUDA device.

enum hwloc_obj_type_t

Type of topology object.

Note
  Do not rely on the ordering or completeness of the values as new ones may be defined in the future! If you need to compare types, use hwloc_compare_types() instead.

Enumerator
HWLOC_OBJ_SYSTEM | Whole system (may be a cluster of machines). The whole system that is accessible to hwloc. That may comprise several machines in SSI systems like Kerrighed.
HWLOC_OBJ_MACHINE | Machine. The typical root object type. A set of processors and memory with cache coherency.
HWLOC_OBJ_NODE | NUMA node. A set of processors around memory which the processors can directly access.
HWLOC_OBJ_SOCKET | Socket, physical package, or chip. In the physical meaning, i.e. that you can add or remove physically.
HWLOC_OBJ_CACHE | Cache. Can be L1i, L1d, L2, L3, ...
HWLOC_OBJ_CORE | Core. A computation unit (may be shared by several logical processors).
HWLOC_OBJ_PU | Processing Unit, or (Logical) Processor. An execution unit (may share a core with some other logical processors, e.g. in the case of an SMT core). Objects of this kind are always reported and can thus be used as fallback when others are not.
HWLOC_OBJ_GROUP | Group objects. Objects which do not fit in the above but are detected by hwloc and are useful to take into account for affinity. For instance, some operating systems expose their arbitrary processors aggregation this way. And hwloc may insert such objects to group NUMA nodes according to their distances. These objects are ignored when they do not bring any structure.
HWLOC_OBJ_MISC | Miscellaneous objects. Objects without particular meaning, that can e.g. be added by the application for its own use.
HWLOC_OBJ_BRIDGE | Bridge. Any bridge that connects the host or an I/O bus, to another I/O bus. Bridge objects have neither CPU sets nor node sets. They are not added to the topology unless I/O discovery is enabled with hwloc_topology_set_flags().
HWLOC_OBJ_PCI_DEVICE | PCI device. These objects have neither CPU sets nor node sets. They are not added to the topology unless I/O discovery is enabled with hwloc_topology_set_flags().
HWLOC_OBJ_OS_DEVICE | Operating system device. These objects have neither CPU sets nor node sets. They are not added to the topology unless I/O discovery is enabled with hwloc_topology_set_flags().
HWLOC_OBJ_TYPE_MAX | Sentinel value

## Function Documentation

int hwloc_compare_types | ( | hwloc_obj_type_t | type1,
|  | hwloc_obj_type_t | type2
| ) |  |

Compare the depth of two object types.

Types shouldn't be compared as they are, since newer ones may be added in the future. This function returns less than, equal to, or greater than zero respectively if `type1` objects usually include `type2` objects, are the same as `type2` objects, or are included in `type2` objects. If the types can not be compared (because neither is usually contained in the other), HWLOC_TYPE_UNORDERED is returned. Object types containing CPUs can always be compared (usually, a system contains machines which contain nodes which contain sockets which contain caches, which contain cores, which contain processors).

Note
  HWLOC_OBJ_PU will always be the deepest.
  This does not mean that the actual topology will respect that order: e.g. as of today cores may also contain caches, and sockets may also contain nodes. This is thus just to be seen as a fallback comparison method.